/****************************************************************************
* Project Name : NiuTrans Server Decoder
* File Name    : timer.h
* Author       : Wang Qiang
* Email        : wangqiang@zjyatuo.com
* Create Time  : 2016/1/15 10:53:46
* Copyright    : Copyright (c) 2016 Shenyang YaTrans Network Technology Co., Ltd. All Rights Reserved.
*
* toolkit used for timer
*
****************************************************************************/

#ifndef _TIMER_H_
#define _TIMER_H_

#include <string>
#ifdef _WIN32
#include <windows.h>
#else
#include       <sys/time.h>
#include       <time.h>

#endif



class timer_c {

public:
	timer_c();
	~timer_c();
	void m_start_timer();
	void m_end_timer();
	double m_get_time_diff_sec();
	double m_get_time_diff_msec();

public:
	static void m_current_time_to_str(std::string & output);

private:
	double m_get_time_diff();                                          /* get the time difference in unit of usec(1.0e-6 sec) */

private:
#ifdef  WIN32
	 DWORD  m_start_time;
	 DWORD  m_end_time;
#else
	struct timeval             m_start_time;
	struct timeval             m_end_time;
#endif

};



#endif